language = "spanish"

function setlanguage()
	if language == "spanish" then
		level_completed = "Nivel completado."
		c_level = "Nivel actual: "
		game_finished = "Felicidades, has conseguido pasarte el juego entero! ¿Deseas volver a jugar?"
	else
		level_completed = "Level completed."
		c_level = "Current level: "
		game_finished = "Congrats, you have beaten the game! Would you like to play again?"
	end
end
setlanguage()

imgsplashsb2011= image.load("img/splashsb2011.png")

function splashsb2011()
	for i = 0, 190 do
		imgsplashsb2011:blend(0,0,i)
		screen.flip()
	end
	for i = 190, 0,-1 do
		imgsplashsb2011:blend(0,0,i)
		screen.flip()
	end
end	


dofile("levels.lua");
arch = io.open("level.txt","r"); --[[io.seek(arch,"set");]] rlvl = arch:read("*n"); io.flush(arch); arch:close();
cnv = rlvl or 1
creditseng = image.load("img/creditseng.png")
creditsesp = image.load("img/creditsesp.png")
finishedeng = image.load("img/finishedeng.png")
finishedesp = image.load("img/finishedesp.png")
controlseng = image.load("img/controlseng.png")
controlsesp = image.load("img/controlsesp.png")
menueng = image.load("img/menueng.png")
menuspa = image.load("img/menuspa.png")
colors = {color.new(255,0,0),color.new(0,255,0),color.new(0,0,255),color.new(255,255,255),color.new(0,0,0)}
function change_colors()
color_mini = colors[math.random(1,5)]
color_big =colors[math.random(1,5)]
end 
change_colors()
tile={size = 30,mini_size =15}
puntero={img = image.load("img/puntero.png"),x=150,y=150}
pos={}
tiles={}
base = image.load("img/base.png")
mini_tiles={}
for i = 1, 4 do
tiles[i] = image.load("img/tiles/"..i..".png")
mini_tiles[i] = image.load("img/tiles/mini/"..i..".png")
end
map = {x = 65, y = 65}
minimap = {x = 370, y = 340}
current_level={}


function blitbase()
	base:blit(0,0)
	if language == "spanish" then
		controlsesp:blit(0,0)
	elseif language == "english" then
		controlseng:blit(0,0)
	end	
end

function notout(x,y)
if pos.y+y+1 > 0 and  pos.x+x+1 > 0 and 
pos.y+y <= 7 and pos.x+x+1 <=13 then
return true else return false end
end

function savelevel()
	local arch = io.open("level.txt","w+"); --[[io.seek(arch,"set");]] arch:write(cnv); io.flush(arch); io.close(arch);
end

function gamefinished()
	cnv = 1
	load(cnv)
	savelevel()	
	while true do
	controls.read()
	if language == "spanish" then
		finishedesp:blit(0,0)
	elseif language == "english" then
		finishedeng:blit(0,0) 
	end
	puntero.img:blit(controls.wiimote.irx(),controls.wiimote.iry())
	if controls.wiimote.press("a") then
		if col2(controls.wiimote.irx(),controls.wiimote.iry(),0,0,231,193,176,42) then
			mainmenu()
		elseif col2(controls.wiimote.irx(),controls.wiimote.iry(),0,0,231,254,176,42) then
			os.exit()
		end	
	end	
	screen.flip()
	end
end

function check_level()
isequal=true
alllevel = ""
for i=1,#current_level do
	alllevel = alllevel..string.implode(current_level[i])
end
if string.implode(level[cnv]) != alllevel then isequal = false end
if isequal == true then
	if cnv >= #level then
		gamefinished()
	else
		cnv=cnv+1
		explosion()
		load(cnv)
		savelevel()
	end
end
end

function aum(y,x)
	if current_level[y][x] < 4 then current_level[y][x] = current_level[y][x] +1
	elseif current_level[y][x] == 4 then current_level[y][x] = 1 end
end

function load(lvl)
current_level={
			{0,0,0,0,0,0,0,0,0,0,0,0,0},
			{0,0,0,0,0,0,0,0,0,0,0,0,0},
			{0,0,0,0,0,0,0,0,0,0,0,0,0},
			{0,0,0,0,0,0,0,0,0,0,0,0,0},
			{0,0,0,0,0,0,0,0,0,0,0,0,0},
			{0,0,0,0,0,0,0,0,0,0,0,0,0},
			{0,0,0,0,0,0,0,0,0,0,0,0,0}
			}
pos.x = math.floor((puntero.x-map.x)/30);
pos.y = math.floor((puntero.y-map.y)/30);
end

function blit_level(lvl)
	for y = 1, 7 do
		for x = 1, 13 do
			n = (y-1)*13+x
			if current_level[y][x] != 0 then  tiles[current_level[y][x]]:blit(map.x+(x-1)*30,map.y+30*(y-1))  end
			if level[lvl][n] != 0 then mini_tiles[level[lvl][n]]:blit(minimap.x+(x-1)*15,minimap.y+15*(y-1)) end
		end
	end
end

function tile_goto(x,y,t)
	ix = ({math.random(-50,puntero.x-50),math.random(puntero.x+75,640)})[math.random(1,2)]
	iy = ({math.random(-50,puntero.y-50),math.random(puntero.y+75,480)})[math.random(1,2)]
	x1= map.x+(x-1)*30
	y1= map.y+(y-1)*30
	if x1>=ix then
		x2=(640-ix)-(640-x1)
	else x2=ix-x1 end
	if y1>=iy then
		y2=(480-iy)-(480-y1)
	else y2=iy-y1 end
	ang = math.atan2(y2,x2)
	hi = math.sqrt((x2*x2+y2*y2))

	for i = 1, hi,15 do
		blitbase()
		if x1>=ix then
			angx=ix+math.cos(-ang)*i
		else
			angx=ix+math.cos(math.pi+ang)*i
		end
		if y1>=iy then
			angy=iy+math.sin(ang)*i
		else
			angy=iy+math.sin(math.pi+ang)*i
		end
		controls.read()
		move_cursor()
		blit_main()
		blit_level(cnv)
		tiles[t]:blit(angx,angy)
		screen.flip()
	end
end

function explosion()
	for i= 1, 640,12 do
		blitbase()
		blit_main()
		for y = 1, 7 do
			for x = 1, 13 do
				if current_level[y][x] != 0 then tiles[current_level[y][x]]:blit(map.x+(x-1)*30+math.cos(math.rad((current_level[y][x]-1)*90))*i,map.y+30*(y-1)+math.sin((math.rad((current_level[y][x]-1)*90)))*i) end
			end
		end
		screen.flip()
	end
end

function move_cursor()
	puntero.x = controls.wiimote.irx()
	puntero.y = controls.wiimote.iry()
end

load(cnv)

function blit_main()
	draw.rect(map.x+pos.x*30,map.y+pos.y*30,30,30,color_big);
	draw.rect(minimap.x+pos.x*15,minimap.y+pos.y*15,15,15,color_mini);
	screen.print(460,15,c_level..cnv.."/40",1,color.new(255,255,255),0x0);
	puntero.img:blit(puntero.x,puntero.y)
end

function col2(x,y,w,h,x1,y1,w1,h1)
	if x + w >= x1 and x <= x1 +w1 and
		y + h >= y1 and y <= y1 +h1 then
		return true
	end
	return false
end


function mainmenu()
	while true do
	controls.read()
	if language == "spanish" then
		menuspa:blit(0,0)
		if col2(controls.wiimote.irx(),controls.wiimote.iry(),0,0,226,262,192,46) then
			creditsesp:blit(0,0)
		end
	elseif language == "english" then
		menueng:blit(0,0) 
		if col2(controls.wiimote.irx(),controls.wiimote.iry(),0,0,226,262,192,46) then
			creditseng:blit(0,0)
		end
	end
	puntero.img:blit(controls.wiimote.irx(),controls.wiimote.iry())
	if controls.wiimote.press("a") then
		if col2(controls.wiimote.irx(),controls.wiimote.iry(),0,0,226,197,192,46) then
			playgame()
		elseif col2(controls.wiimote.irx(),controls.wiimote.iry(),0,0,226,326,192,46) then
			if language == "spanish" then language = "english" else language = "spanish" end setlanguage();
		elseif col2(controls.wiimote.irx(),controls.wiimote.iry(),0,0,226,389,192,46) then
			os.exit()
		end	
	end	
	screen.flip()
	end
end






function playgame()
	load(cnv)
	while (true) do
		if puntero.x>map.x and puntero.x<map.x+13*tile.size and puntero.y>map.y and puntero.y<map.y+7*tile.size then
			pos.x = math.floor((puntero.x-map.x)/30)
			pos.y = math.floor((puntero.y-map.y)/30)
		end
	controls.read();

	--Reset level
		if controls.wiimote.press("one") then load(cnv) end
		if controls.wiimote.press("minus") then cnv = math.max(1,cnv-1); load(cnv) end
		if controls.nunchuk.c() and controls.nunchuk.z() then cnv = 1; load(cnv) end


	--[[if controls.triangle() and controls.square() and controls.cross() and controls.circle() then
		if controls.up() and controls.press("l") then
			cnv = math.min(#level,cnv+1)
			load(cnv)
		end
		if controls.down() and controls.press("l") then
			cnv = math.max(1,cnv-1)
			load(cnv)
		end
		if controls.l() and controls.press("r") then
			cnv = 40
			load(cnv)
		end
	end]]

	move_cursor()

	if controls.wiimote.press("a") then
			if current_level[pos.y+1][pos.x+1] == 0 then
				tile_goto(pos.x+1,pos.y+1,1)
				change_colors()
				current_level[pos.y+1][pos.x+1] = 1
				if pos.y+1+(1) > 0 and  pos.x+1+(0) > 0 and 
					pos.y+1+(1) <= 7 and pos.x+1+(0) <=13 then
						if current_level[pos.y+1+(1)][pos.x+1+(0)] != 0 then
							aum(pos.y+1+(1),pos.x+1+(0))
						end
				end
				if pos.y+1+(-1) > 0 and  pos.x+1+(0) > 0 and 
					pos.y+1+(-1) <= 7 and pos.x+1+(0) <=13 then
					if current_level[pos.y+1+(-1)][pos.x+1+(0)] != 0 then
						aum(pos.y+1+(-1),pos.x+1+(0))
					end
				end
				if pos.y+1+(0) > 0 and  pos.x+1+(1) > 0 and 
					pos.y+1+(0) <= 7 and pos.x+1+(1) <=13 then
					if current_level[pos.y+1+(0)][pos.x+1+(1)] != 0 then
						aum(pos.y+1+(0),pos.x+1+(1))
					end
				end
				if pos.y+1+(0) > 0 and  pos.x+1+(-1) > 0 and 
					pos.y+1+(0) <= 7 and pos.x+1+(-1) <=13 then
					if current_level[pos.y+1+(0)][pos.x+1+(-1)] != 0 then
						aum(pos.y+1+(0),pos.x+1+(-1))
					end
				end
			end
			blitbase()
		blit_level(cnv)
		blit_main()
		screen.flip()
		check_level()
	else blitbase() blit_level(cnv); blit_main(); screen.flip() end
	if controls.wiimote.home() then mainmenu() end
	if controls.wiimote.press("two") then image.save("screenshot.png") end
	end
end
splashsb2011()
mainmenu()